/* 
 * wsdl2cpp - A C++ parser  for WSDL  (Web services description language)
 * Copyright (C) 2003 Vivek Krishna
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *
 */

/* 
 * Abstract interface for all xsd types
 */


#ifndef _XSDTYPEH
#define _XSDTYPEH

#include <string>
#include  <xmlpull/Qname.h>
#ifdef HAVE_CONFIG_H //
#include <config.h>
#endif             

using namespace std;
const string SchemaUri = "http://www.w3.org/2001/XMLSchema";

class XSDType
{
    public:XSDType(string) { };
    XSDType() { };
    virtual ~ XSDType() { };

    virtual string getName() const = 0;
    virtual Qname getQname() const = 0;
    virtual int getContentModel() const = 0;      //simple,complex or mixed
    virtual int getTypeId() const = 0;
    virtual bool isAnonymous() const = 0;
    virtual bool isSimple() const {
        return true;
    }

    virtual void setName(string) = 0;
    virtual void setContentModel(int) = 0;
    virtual void setTypeId(int) = 0;
    virtual void setAnonymous(bool) = 0;


#ifdef LOGGING
     virtual void print (ostream & out) { };
#endif

//Content Model
    enum
    {
        // Sun Workshop compiler does not like the final comma. -KEC
        SIMPLE = 0, COMPLEX, MIXED
    };

//List of primitive types
    enum
    {
        INVALID = 0, STRING =
        1, INTEGER, INT, BYTE, POSINT, UINT, LONG, ULONG, SHORT,
        USHORT,
        DECIMAL, FLOAT, DOUBLE, BOOLEAN, TIME, DATETIME, DATE, TOKEN,
        QNAME,
        NCNAME, NMTOKEN, NMTOKENS, BASE64BIN, HEXBIN, ANY, ANYTYPE, ANYURI
    };
};
#endif                                            /*  */
