/* 
 * wsdlpull - A C++ parser  for WSDL  (Web services description language)
 * Copyright (C) 2003 Vivek Krishna
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *
 */
#ifndef _WSDLH
#define _WSDLH

//Common defines for all wsdl related components
const int MAX_SCHEMAS = 5;                        /*maximum number of schemas inside the <types> */
const int MAX_OPS = 30;                           /*maximum number of operations in a port type */
const int MAX_PARTS = 12;                         /*maximum number of parts in a message */
const int MAX_PTYPES = 4;                         /*maximum number of port types */
const int MAX_EXT = 6;                            /*maximum number of extensibility handlers supported */
const int MAX_EXT_ELEM = 6;                       /*maximum number of extensibility elements in a WSDL elem */
const int MAX_EXT_ATTS = 15;                      /*maximum number of extensibility attributes in a WSDL elem */
const int MAX_EXT_XML = 60;
const int MAX_OPS_PER_PT = 6;

/*maximum number  xml information elements per extensibility instance
                           in a WSDl document*/
enum refType
{
    None, Elem, Type
};
enum Optype
{
    INVALID = -1, IN = 0, OUT, IN_OUT, OUT_IN
};
enum messageType
{
    Input = 0, Output, Fault
};
#endif                                            /*  */
