/* 
 * wsdlpull - A C++ parser  for WSDL  (Web services description language)
 * Copyright (C) 2003 Vivek Krishna
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *
 */
#ifndef _QNAMEH
#define _QNAMEH

#include <string>
using namespace std;

class Qname
{
    public:
	Qname (const string & name)
    {
        parse (name);
    }
    Qname (const Qname & qn)
    {
        localname = qn.localname;
        prefix = qn.prefix;
        namespaceUri = qn.namespaceUri;
    }
    Qname ():localname (), prefix (), namespaceUri ()
    {
    }
    void operator = (const string & name)
    {
        parse (name);
    }
    string  getLocalName (void)const
    {
        return localname;
    }
    string  getPrefix (void) const
    {
        return prefix;
    }
    string  getNamespace (void)const
    {
        return namespaceUri;
    }
    void setNamespace (string uri)
    {
        namespaceUri = uri;
    }
    bool operator == (const Qname & qn)const
    {
        if (qn.getNamespace () == namespaceUri && qn.getLocalName () == localname)
            return true;
    }
    private:void parse (const string & name)
    {
        int cut = -1;
        if (name.empty ())
            return;
        cut = name.find (":");
        if (cut == -1 || cut == 0)
            localname = name;

        else

        {
            localname = name.substr (cut + 1);
            prefix = name.substr (0, cut);
        }
        cut = localname.find ("[]");
        if (cut > 0)
            localname = localname.substr (0, cut);
    }
    string namespaceUri, localname, prefix;
};
#endif                                            /*  */
